(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('oidc-client'), require('@ionic-native/in-app-browser/ngx'), require('@ionic/angular'), require('totvs-log-base-foundation'), require('totvs-log-mobile-foundation/src/oidc-cordova'), require('@angular/core'), require('@angular/common/http')) :
    typeof define === 'function' && define.amd ? define('totvs-log-mobile-foundation/src/auth', ['exports', 'oidc-client', '@ionic-native/in-app-browser/ngx', '@ionic/angular', 'totvs-log-base-foundation', 'totvs-log-mobile-foundation/src/oidc-cordova', '@angular/core', '@angular/common/http'], factory) :
    (factory((global['totvs-log-mobile-foundation'] = global['totvs-log-mobile-foundation'] || {}, global['totvs-log-mobile-foundation'].src = global['totvs-log-mobile-foundation'].src || {}, global['totvs-log-mobile-foundation'].src.auth = {}),global.oidcClient,global.ngx,global.angular,global.totvsLogBaseFoundation,global['totvs-log-mobile-foundation'].src['oidc-cordova'],global.ng.core,global.ng.common.http));
}(this, (function (exports,oidcClient,ngx,angular,totvsLogBaseFoundation,oidcCordova,core,http) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AuthService = /** @class */ (function (_super) {
        __extends(AuthService, _super);
        /**
         * Método construtor da classe
         * authSettings Token de injeção com as configurações de autenticação
         * authType Token de injeção com o tipo de autenticação
         */
        function AuthService(authSettings, authType, events) {
            var _this = _super.call(this, authSettings) || this;
            _this.events = events;
            _this.authType = authType;
            return _this;
        }
        /**
         * Método responsável executar o processo de login/autenticação
         */
        /**
         * Método responsável executar o processo de login/autenticação
         * @return {?}
         */
        AuthService.prototype.loginFlow = /**
         * Método responsável executar o processo de login/autenticação
         * @return {?}
         */
            function () {
                return __awaiter(this, void 0, void 0, function () {
                    var loaded_1, doneFn_1, loadedFn_1, failedFn_1, doneProm_1, error_1;
                    var _this = this;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (!(this.authType.type === totvsLogBaseFoundation.AuthHandlerType.oauth2))
                                    return [3 /*break*/, 4];
                                doneProm_1 = new Promise(( /**
                                 * @param {?} resolve
                                 * @param {?} reject
                                 * @return {?}
                                 */function (resolve, reject) {
                                    doneFn_1 = resolve;
                                }));
                                _a.label = 1;
                            case 1:
                                _a.trys.push([1, 3, , 4]);
                                loadedFn_1 = ( /**
                                 * @return {?}
                                 */function () {
                                    loaded_1 = true;
                                    totvsLogBaseFoundation.UtilsFn.timeout(doneProm_1, 1000);
                                    _this.events.unsubscribe(oidcCordova.OidcCordovaIabEvents.LoadSuccessful, loadedFn_1);
                                });
                                this.events.subscribe(oidcCordova.OidcCordovaIabEvents.LoadSuccessful, loadedFn_1);
                                failedFn_1 = ( /**
                                 * @return {?}
                                 */function () {
                                    loaded_1 = false;
                                    totvsLogBaseFoundation.UtilsFn.timeout(doneProm_1, 1000);
                                    _this.events.unsubscribe(oidcCordova.OidcCordovaIabEvents.LoadFailed, failedFn_1);
                                });
                                this.events.subscribe(oidcCordova.OidcCordovaIabEvents.LoadFailed, failedFn_1);
                                return [4 /*yield*/, this.manager.signinPopup()];
                            case 2:
                                _a.sent();
                                doneFn_1();
                                return [3 /*break*/, 4];
                            case 3:
                                error_1 = _a.sent();
                                doneFn_1();
                                this.events.unsubscribe(oidcCordova.OidcCordovaIabEvents.LoadFailed, failedFn_1);
                                this.events.unsubscribe(oidcCordova.OidcCordovaIabEvents.LoadSuccessful, loadedFn_1);
                                if (!loaded_1 || error_1) {
                                    throw error_1;
                                }
                                return [3 /*break*/, 4];
                            case 4: return [2 /*return*/];
                        }
                    });
                });
            };
        /**
         * Método responsável executar o processo de logout
         */
        /**
         * Método responsável executar o processo de logout
         * @return {?}
         */
        AuthService.prototype.logoutFlow = /**
         * Método responsável executar o processo de logout
         * @return {?}
         */
            function () {
                return __awaiter(this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (!(this.authType.type === totvsLogBaseFoundation.AuthHandlerType.oauth2))
                                    return [3 /*break*/, 2];
                                return [4 /*yield*/, this.manager.signoutPopup()];
                            case 1:
                                _a.sent();
                                _a.label = 2;
                            case 2: return [2 /*return*/];
                        }
                    });
                });
            };
        AuthService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        AuthService.ctorParameters = function () {
            return [
                { type: undefined, decorators: [{ type: core.Inject, args: [totvsLogBaseFoundation.AUTH_SETTINGS,] }] },
                { type: undefined, decorators: [{ type: core.Inject, args: [totvsLogBaseFoundation.AUTH_TYPE,] }] },
                { type: angular.Events }
            ];
        };
        return AuthService;
    }(totvsLogBaseFoundation.AuthBaseService));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} iab
     * @param {?} events
     * @param {?} authSettings
     * @return {?}
     */
    function authFactory(iab, events, authSettings) {
        return Object.assign(authSettings, {
            popupNavigator: new oidcCordova.OidcCordovaPopupNavigator(iab, events),
            checkSessionInterval: authSettings.checkSessionInterval || 30000,
            userStore: new oidcClient.WebStorageStateStore({ store: window.localStorage }),
        });
    }
    /** @type {?} */
    var AUTH_FACTORY = new core.InjectionToken('');
    /**
     * Módulo que exporta e ativa as dependências para utilizar autenticação com fluxo oauth2
     * Para garantir que os serviços tenham uma única instância, usar AuthModule.forRoot() ao importar
     * @export
     * FndModule
     */
    var AuthModule = /** @class */ (function () {
        function AuthModule() {
        }
        /**
         * @dynamic
         */
        /**
         * \@dynamic
         * @param {?} authSettings
         * @param {?} handlerTypeSettings
         * @return {?}
         */
        AuthModule.forRoot = /**
         * \@dynamic
         * @param {?} authSettings
         * @param {?} handlerTypeSettings
         * @return {?}
         */
            function (authSettings, handlerTypeSettings) {
                return {
                    ngModule: AuthModule,
                    providers: [
                        ngx.InAppBrowser,
                        totvsLogBaseFoundation.UserPermissionService,
                        {
                            provide: totvsLogBaseFoundation.AuthBaseService,
                            useClass: AuthService,
                        },
                        {
                            provide: AUTH_FACTORY,
                            useValue: authSettings
                        },
                        {
                            provide: totvsLogBaseFoundation.AUTH_SETTINGS,
                            useFactory: authFactory,
                            deps: [ngx.InAppBrowser, angular.Events, AUTH_FACTORY],
                        },
                        { provide: totvsLogBaseFoundation.AUTH_TYPE, useValue: handlerTypeSettings },
                    ],
                };
            };
        AuthModule.decorators = [
            { type: core.NgModule, args: [{
                        providers: [
                            {
                                provide: http.HTTP_INTERCEPTORS,
                                useClass: totvsLogBaseFoundation.AuthInterceptorHandlerService,
                                multi: true,
                            },
                        ],
                    },] }
        ];
        return AuthModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.authFactory = authFactory;
    exports.AuthModule = AuthModule;
    exports.AuthService = AuthService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=totvs-log-mobile-foundation-src-auth.umd.js.map